"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServerHandler = void 0;
const typescript_1 = require("../helpers/typescript");
const TypeWrapper_1 = require("./TypeWrapper");
class ServerHandler {
    constructor() {
        this.typeWrappers = [];
    }
    onPostHandler(request, response) {
        const event = request.body;
        if ((0, typescript_1.isEventMessage)(event)) {
            this.add(event);
        }
        else {
            console.log({ event });
            throw new Error('Invalid event');
        }
    }
    add(event) {
        const old = this.typeWrappers.find((e) => e.id === event.codeString && e.file === event.file);
        if (old) {
            old.addValue(event.codeValue);
        }
        else {
            this.typeWrappers.push(new TypeWrapper_1.TypeWrapper(event));
        }
        for (const tw of this.typeWrappers) {
            tw.generateType();
        }
        this.onUpdateListener(this.typeWrappers);
    }
    reset() {
        console.log('resetting TI');
        this.typeWrappers = [];
        this.onUpdateListener(this.typeWrappers);
    }
    injectOnUpdateListener(listener) {
        this.onUpdateListener = listener;
    }
}
exports.ServerHandler = ServerHandler;
//# sourceMappingURL=ServerHandler.js.map