"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeWrapper = void 0;
const node_notifier_1 = __importDefault(require("node-notifier"));
const helpers_1 = require("../helpers/helpers");
class TypeWrapper {
    constructor(event) {
        this.id = event.codeString;
        this.file = event.file;
        this.line = event.line;
        this.values = [{ key: 0, value: event.codeValue }];
        this.currentType = '';
    }
    addValue(value) {
        const key = this.values.length;
        this.values.push({ key, value });
        this.generateType();
        node_notifier_1.default.notify(`Got new value for ${this.id}: ${value}`);
    }
    generateType() {
        const types = [];
        for (const value of this.values) {
            const type = (0, helpers_1.typeExtractor)(value.value);
            if (!types.includes(type)) {
                types.push(type);
            }
        }
        const result = types.join(' | ');
        this.currentType = result;
    }
}
exports.TypeWrapper = TypeWrapper;
//# sourceMappingURL=TypeWrapper.js.map