"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.App = void 0;
const react_1 = __importStar(require("react"));
const ink_1 = require("ink");
const server_1 = require("../server");
const ink_gradient_1 = __importDefault(require("ink-gradient"));
const ink_big_text_1 = __importDefault(require("ink-big-text"));
const helpers_1 = require("../../helpers/helpers");
const constants_1 = require("../../constants");
let port = constants_1.DEFAULT_PORT_NUM;
if (process.env.TYPESPY_PORT_NUM) {
    port = parseInt(process.env.TYPESPY_PORT_NUM);
    console.log(`🕵🏻‍♂️ Using non-default port number ${port}`);
}
const typeInspector = (0, server_1.init)(port);
const App = () => {
    const [typesList, setTypesList] = (0, react_1.useState)([]);
    (0, react_1.useEffect)(() => {
        if (process.env.DEMO_MODE) {
            (0, helpers_1.runInTestMode)(typeInspector);
        }
        typeInspector.injectOnUpdateListener((calls) => {
            setTypesList(calls.map((call) => call));
        });
    }, []);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(ink_gradient_1.default, { name: "summer" },
            react_1.default.createElement(ink_big_text_1.default, { text: "typespy", align: "center", font: "chrome" })),
        react_1.default.createElement(ink_1.Box, { borderStyle: "bold", flexDirection: "column" }, typesList.length ? (typesList.map((type) => (react_1.default.createElement(ink_1.Box, { borderStyle: "single", key: type.id, flexDirection: "column" },
            react_1.default.createElement(ink_1.Box, null,
                react_1.default.createElement(ink_1.Text, null,
                    "Code with id [",
                    react_1.default.createElement(ink_1.Text, { color: "yellow", bold: true }, type.id),
                    "] in file",
                    react_1.default.createElement(ink_1.Text, { color: "blue" }, ` ${type.file}:${type.line} `),
                    "has type ",
                    react_1.default.createElement(ink_1.Text, { color: "green" }, type.currentType))),
            react_1.default.createElement(ink_1.Box, null, type.values.map((value) => (react_1.default.createElement(ink_1.Box, { borderStyle: "round", borderColor: "gray", key: value.key },
                react_1.default.createElement(ink_1.Text, { color: "magenta" }, (0, helpers_1.valuePrinter)(value.value)))))))))) : (react_1.default.createElement(ink_1.Text, null,
            "I'm spying on your types (\uFF65_\u251C\u252C\u2534\u252C\u2534",
            react_1.default.createElement(ink_1.Newline, null),
            "add a",
            ' ',
            react_1.default.createElement(ink_1.Text, { color: "gray", italic: true },
                ' ',
                "// spy code_here",
                ' '),
            "comment and restart your application")))));
};
exports.App = App;
//# sourceMappingURL=App.js.map